<?php

namespace Bydedi\Mail;

use Swift_Mailer;
use Swift_Plugins_Logger;
use Swift_Plugins_LoggerPlugin;
use Symfony\Component\EventDispatcher\EventDispatcherInterface;

class Mailer
{

    /**
     * @var Swift_Mailer
     */
    protected $swift;
    /**
     * @var \Symfony\Component\EventDispatcher\EventDispatcherInterface
     */
    protected $dispatcher;

    /**
     * @var Swift_Plugins_Logger
     */
    protected $logger;

    public function __construct(Swift_Mailer $swift, EventDispatcherInterface $dispatcher, Swift_Plugins_Logger $logger = null)
    {
        $this->swift = $swift;
        $this->dispatcher = $dispatcher;
        $this->logger = $logger;

        $this->swift->registerPlugin(new Swift_Plugins_LoggerPlugin($this->logger));
    }

    /**
     * @param Message $message
     * @return int
     */
    public function send(Message $message)
    {
        $response = $this->swift->send($message);

        // dump($this->logger->dump());

        return $response;
    }

}
